#include "mainwindow.h"
#include "ui_mainwindow.h"



#define AN0	0 	//LDR
#define AN1	1 	//JoyPotX
#define AN2	2 	//joyPotY
#define AN3	3	//ModPot

#define DAC	4

const char PCF8591 = 0x48; // base address
int fd, DACval;



void InitHW()

{
    wiringPiSetup();
    fd = wiringPiI2CSetup(PCF8591);
}


MainWindow::MainWindow(QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::MainWindow)
{
    ui->setupUi(this);

    InitHW();
    timer = new QTimer(this);
    connect(timer, SIGNAL(timeout()), this, SLOT(Timer_1()));
    timer->start(5);
}

MainWindow::~MainWindow()
{
    delete ui;
    timer->stop();
}

void MainWindow::Timer_1()
{
   int ANOval,AN1val, AN2val, AN3val;

    //Read AN0 LDR
    wiringPiI2CReadReg8(fd, PCF8591 + AN0) ; // dummy read
    ANOval = wiringPiI2CReadReg8(fd, PCF8591 + AN0);

    //Read AN1 Xpot
    wiringPiI2CReadReg8(fd, PCF8591 + AN1) ; // dummy read
    AN1val = wiringPiI2CReadReg8(fd, PCF8591 + AN1);

    //Read AN2 Ypot
    wiringPiI2CReadReg8(fd, PCF8591 + AN2) ; // dummy read
    AN2val = wiringPiI2CReadReg8(fd, PCF8591 + AN2);

    //Read AN3 POT
    wiringPiI2CReadReg8(fd, PCF8591 + AN3) ; // dummy read
    AN3val = wiringPiI2CReadReg8(fd, PCF8591 + AN3);

    // write to DAC reg, 0x04
    wiringPiI2CWriteReg8 (fd, PCF8591 + DAC, DACval);

    ui->progressBar->setValue(AN1val);
    ui->progressBar_2->setValue(AN2val);
    ui->progressBar_3->setValue(AN3val);
    ui->progressBar_4->setValue(ANOval);

}

void MainWindow::on_horizontalSlider_valueChanged(int value)
{
    DACval = value;
}
